PRINT N'Quitando [dbo].[DF_User_IsExternalSupervisor]...';


GO
ALTER TABLE [dbo].[User] DROP CONSTRAINT [DF_User_IsExternalSupervisor];


GO
PRINT N'Quitando [dbo].[DF_User_IsExternalAgent]...';


GO
ALTER TABLE [dbo].[User] DROP CONSTRAINT [DF_User_IsExternalAgent];


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[User]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_User] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [ID]                   VARCHAR (50)  NOT NULL,
    [Email]                VARCHAR (100) NULL,
    [Firstname]            VARCHAR (100) NULL,
    [Lastname]             VARCHAR (100) NULL,
    [Password]             VARCHAR (100) NULL,
    [Role]                 VARCHAR (50)  NULL,
    [Country]              VARCHAR (50)  NULL,
    [Language]             VARCHAR (50)  NULL,
    [TimeZone]             VARCHAR (50)  NULL,
    [Preferences]          VARCHAR (200) NULL,
    [IsSystemUser]         BIT           NULL,
    [IsLocalSupervisor]    BIT           CONSTRAINT [DF_User_IsLocalSupervisor] DEFAULT ((0)) NULL,
    [IsExternalSupervisor] BIT           CONSTRAINT [DF_User_IsExternalSupervisor] DEFAULT ((0)) NULL,
    [IsExternalAgent]      BIT           CONSTRAINT [DF_User_IsExternalAgent] DEFAULT ((0)) NULL,
    [LimitClients]         BIT           NULL,
    [API]                  BIT           NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_User1] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[User])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_User] ([VCC], [ID], [Email], [Firstname], [Lastname], [Password], [Role], [Country], [Language], [TimeZone], [Preferences], [IsSystemUser], [IsExternalSupervisor], [IsExternalAgent], [LimitClients], [API], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [Email],
                 [Firstname],
                 [Lastname],
                 [Password],
                 [Role],
                 [Country],
                 [Language],
                 [TimeZone],
                 [Preferences],
                 [IsSystemUser],
                 [IsExternalSupervisor],
                 [IsExternalAgent],
                 [LimitClients],
                 [API],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[User]
        ORDER BY [VCC] ASC, [ID] ASC;
    END

DROP TABLE [dbo].[User];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_User]', N'User';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_User1]', N'PK_User', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Modificando [dbo].[GetUser]...';


GO
ALTER PROCEDURE [dbo].[GetUser] (
	@VCC Varchar(50) = NULL, @UserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[ID]								'id',
		[Email] 							'email',
		[Firstname] 						'firstname',
		[Lastname] 							'lastname',
		[Role] 								'role',
		[Country] 							'country',
		[Language] 							'language',
		[TimeZone] 							'timeZone',
		[Preferences] 						'preferences',
		[IsSystemUser] 						'isSystemUser',
		[IsLocalSupervisor]					'isLocalSupervisor',
		[IsExternalSupervisor]				'isExternalSupervisor',
		[IsExternalAgent]					'isExternalAgent',
		[LimitClients] 						'limitClients',
		[API]								'api',
		[CreatedDate]						'createdDate',
		[CreatedByUserId]					'createdByUserId',
		[LastModifiedDate]					'lastModifiedDate',
		[LastModifiedByUserId]				'lastModifiedByUserId'
	FROM [User] (NOLOCK)
	WHERE [VCC] = @VCC
	AND [ID] = @UserId
	
	EXEC [GetUserClient] @VCC, @UserId
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveUser]...';


GO
ALTER PROCEDURE [dbo].[SaveUser] (
	@VCC Varchar(50) = NULL, 					@ID Varchar(50) = NULL, 				@Email Varchar(50) = NULL,
	@Firstname Varchar(50) = NULL, 				@Lastname Varchar(50) = NULL, 			@Password Varchar(50) = NULL,
	@Role Varchar(50) = NULL, 					@Country Varchar(50) = NULL, 			@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,				@Preferences Varchar(200) = NULL, 		@IsSystemUser Bit = NULL,
	@IsLocalSupervisor BIT = 0,
	@IsExternalSupervisor BIT = 0,
	@IsExternalAgent BIT =0,				
	@LimitClients Bit = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [User]
	SET [Email] = @Email,
		[Firstname] = @Firstname,
		[Lastname] = @Lastname,
		[Password] = CASE WHEN @Password IS NULL OR @Password = '' THEN [Password] ELSE @Password END,
		[Role] = @Role,
		[Country] = @Country,
		[Language] = @Language,
		[TimeZone] = @TimeZone,
		[Preferences] = @Preferences,
		[IsSystemUser] = @IsSystemUser,
		[IsLocalSupervisor] = @IsLocalSupervisor,
		[IsExternalSupervisor] = @IsExternalSupervisor,
		[IsExternalAgent] = @IsExternalAgent,
		[LimitClients] = @LimitClients,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
	AND [ID] = @ID
    
    IF @@ROWCOUNT = 0
		INSERT INTO [User] (
			[VCC], [ID], [Email],
			[Firstname], [Lastname], [Password],
			[Role], [Country], [Language],
			[TimeZone], [Preferences], [IsSystemUser],
			[IsLocalSupervisor], 
			[IsExternalSupervisor], 
			[IsExternalAgent], 
			[LimitClients], 
			[CreatedDate], 
			[CreatedByUserId],
			[LastModifiedDate], 
			[LastModifiedByUserId],
			[TimeStamp]
			)
		VALUES (
			@VCC, @ID, @Email,
			@Firstname, @Lastname, @Password,
			@Role, @Country, @Language,
			@TimeZone, @Preferences, @IsSystemUser,
			@IsLocalSupervisor,
			@IsExternalSupervisor, 
			@IsExternalAgent, 
			@LimitClients, 
			@CreatedDate, @CreatedByUserId,
			@LastModifiedDate, @LastModifiedByUserId,
			GETUTCDATE()
		)
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAuditors]...';


GO


ALTER PROCEDURE [dbo].[GetAuditors] (
	@Instance Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
 	SELECT T.ID								'id',
			U.lastname + ' ' + U.Firstname	'name',
			U.Firstname						'firstname',
			U.lastname						'lastname',
			U.email							'email',
			U.[IsLocalSupervisor]			'isLocalSupervisor',
			U.[IsExternalSupervisor]		'isExternalSupervisor',
			U.[IsExternalAgent]				'isExternalAgent',
			T.CreatedDate					'createdDate',
			T.CreatedByUserId				'createdByUserId',
			T.LastModifiedDate				'lastModifiedDate',
			T.LastModifiedByUserId			'lastModifiedByUserId'
		FROM [dbo].[Auditor] T (NOLOCK)
		INNER JOIN [dbo].[User] U (NOLOCK)
			ON U.[VCC] = T.[Instance]
				AND U.[ID] = T.[ID]
		WHERE T.Instance = @Instance
			AND ISNULL(t.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
 	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetSupervisors]...';


GO


create PROCEDURE [dbo].[GetSupervisors] (
	@VCC VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
 	SELECT U.[VCC]															'vcc',
			U.[Id]															'userId',
			CONCAT(U.[Firstname], ' ', ISNULL(U.[Lastname], ''))			'userName',
			NULL															'campaignId',
			NULL															'workGroupId'
		FROM [dbo].[User] U (NOLOCK)
		WHERE U.[VCC] = @VCC
			AND (
				U.[IsLocalSupervisor] = 1
				OR
				U.[IsExternalSupervisor] = 1
			)
 	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[GetUsers]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetUsers]';


GO
PRINT N'Actualizando [dbo].[RollbackVcc]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[RollbackVcc]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlansAuditor]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlansAuditor]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationsOfInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationsOfInteraction]';


GO
PRINT N'Actualizando [dbo].[GetAgentsFromEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAgentsFromEvaluation]';


GO
PRINT N'Actualizando [dbo].[GetCampaignsFromEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignsFromEvaluation]';


GO
PRINT N'Actualizando [dbo].[GetDispositionCodesFromEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetDispositionCodesFromEvaluation]';


GO
PRINT N'Actualizando [dbo].[SaveIntegratedUser]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveIntegratedUser]';


GO
PRINT N'Actualizando [dbo].[ValidateUserLogin]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ValidateUserLogin]';


GO
PRINT N'Actualizando [dbo].[DeleteUser]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteUser]';


GO
PRINT N'Actualizando [dbo].[SaveSpeechAnalyticAuditorUser]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveSpeechAnalyticAuditorUser]';


GO
PRINT N'Actualizando [dbo].[GetAuditorsInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorsInteractions]';


GO
PRINT N'Actualizando [dbo].[CreateVcc]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[CreateVcc]';


GO
PRINT N'Actualizando [dbo].[SaveVcc]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveVcc]';


GO
PRINT N'Actualización completada.';


GO
