PRINT N'Altering Procedure [dbo].[GetTemplateThemeModels]...';


GO
ALTER PROCEDURE [dbo].[GetTemplateThemeModels] (
	@VCC Varchar(50) = NULL, 
	@TemplateId Varchar(50) = NULL,
	@TemplateThemeId Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DETERMINAR SI ES UN FORMATO O PLANTILLA
	DECLARE @TEMPLATE_TYPE VARCHAR(50) = NULL

	-- BUSCAMOS POR EL ID SI SE TRATA DE UNA PLANTILLA O FORMATO
	IF EXISTS (
		SELECT 1 
			FROM [dbo].[Template] T (NOLOCK)
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = T.[VCC]
					AND EF.[templateId] = T.[Name]
			WHERE T.[VCC] = @VCC
				AND T.[Name] = @TemplateId
	)
		SET @TEMPLATE_TYPE = 'EVALUATION_FORMAT'
	ELSE 
		SET @TEMPLATE_TYPE = 'TEMPLATE'

	-- 
	SELECT A.[VCC]												'vcc',	
			A.[TemplateId]										'templateId',
			A.[TemplateThemeId]									'templateThemeId',
			A.[ID]												'id',
			-- CASE WHEN ISNULL(B.[Query],'') = ISNULL(NULL,'') THEN A.[ID] ELSE B.[Query] END	'query',
			--A.[ID]												'query',
			CASE WHEN @TEMPLATE_TYPE = 'EVALUATION_FORMAT' 
				THEN A.[ID]
				ELSE 
					CASE WHEN NI.[nluId] IS NOT NULL 
						THEN NI.[nluId] + '|' + NI.[intentId]
						ELSE A.[ID]
						END
				END												'query',
			@TEMPLATE_TYPE										'templateType',
			A.[AcceptancePercentage]							'acceptancePercentage',
			ISNULL(A.[AcceptancePercentage],0) * 100			'acceptanceInteger',
			A.[CreatedDate]										'createdDate',
			A.[CreatedByUserId]									'createdByUserId',
			A.[LastModifiedDate]								'lastModifiedDate',
			A.[LastModifiedByUserId]							'lastModifiedByUserId'
		FROM [TemplateThemeItem] A (NOLOCK)
		INNER JOIN [dbo].[TemplateTheme] TT (NOLOCK)
			ON TT.[VCC] = A.[VCC]
				AND TT.[ID] = A.[TemplateThemeId]
		LEFT JOIN [dbo].[GenericQuery] B (NOLOCK) 
			ON A.[ID] = B.[Name] 
				AND A.[VCC] = B.[VCC]
		LEFT JOIN (
			SELECT DISTINCT
					INNER_N.[VCC]								'vcc'
					,INNER_N.[Name] + '|'+ INNER_I.[Name]		'cognitiveId'
					,INNER_N.[Name]								'nluId'
					,INNER_N.[AppId]							'appId'
					,INNER_I.[IntentId]							'intentId'
					,INNER_I.[Name]
				FROM [dbo].[NLU] INNER_N (NOLOCK)
				INNER JOIN [dbo].[Intent] INNER_I (NOLOCK) 
					ON INNER_N.[VCC] = INNER_I.[VCC]
						AND INNER_N.AppId = INNER_I.[AppId] 
				WHERE INNER_N.[VCC] = @VCC
		) NI 
			ON NI.[vcc] = A.[VCC]
				AND NI.[cognitiveId] = A.[ID]
		WHERE A.[VCC] = @VCC
			AND A.[TemplateId] = CASE WHEN ISNULL(@TemplateId, '') = '' THEN A.[TemplateId] ELSE @TemplateId END
			AND A.[TemplateThemeId] = CASE WHEN ISNULL(@TemplateThemeId, '') = '' THEN A.[TemplateThemeId] ELSE @TemplateThemeId END
			AND B.[Name] IS NULL

	SET NOCOUNT OFF
END
GO
PRINT N'Update complete.';


GO
