PRINT N'Altering Table [dbo].[SentimentAnalysisResult]...';


GO
ALTER TABLE [dbo].[SentimentAnalysisResult]
    ADD [EndDate] DATETIME NULL;


GO
PRINT N'Altering Procedure [dbo].[SaveSentimentAnalysisResult]...';


GO
ALTER PROCEDURE [dbo].[SaveSentimentAnalysisResult] (
	@VCC varchar(50),
	@InteractionId varchar(250),
	@InteractionSection numeric(5,0),
	@InteractionPart numeric(5,0),
	@InteractionType varchar(50),
	@InteractionInterval numeric(5,0),
	@AnalysisType varchar(50),
	@SentimentId varchar(50),
	@AppId varchar(50),
	@Score numeric(10,5),
	@CreatedDate datetime,
	@CreatedByUserId varchar(50),
	@LastModifiedDate datetime,
	@LastModifiedByUserId varchar(50),
	@EndDate varchar(50)
	)
AS
BEGIN
	SET NOCOUNT ON
	UPDATE [SentimentAnalysisResult]
	SET [VCC] = @VCC,
		[InteractionId] = @InteractionId,
		[InteractionSection] = @InteractionSection,
		[InteractionPart] = @InteractionPart,
		[InteractionType] = @InteractionType,
		[InteractionInterval] = @InteractionInterval,
		[AnalysisType] = @AnalysisType,
		[SentimentId] = @SentimentId,
		[AppId] = @AppId,
		[Score] = @Score,		
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = GETUTCDATE(),
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE(),
		[EndDate] = @EndDate
		
	WHERE [VCC] = @VCC
    AND [InteractionId] = @InteractionId
	AND [InteractionSection] = @InteractionSection
	AND	[InteractionPart] = @InteractionPart
	AND [InteractionType] = @InteractionType
	AND [InteractionInterval] = @InteractionPart
	AND [AnalysisType] = @AnalysisType
	AND [SentimentId] = @SentimentId
	AND [AppId] = @AppId
	AND [EndDate] = @EndDate
	

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [SentimentAnalysisResult] (
			[VCC], 
			[InteractionId],
			[InteractionSection],
			[InteractionPart],
			[InteractionType],
			[InteractionInterval],
			[AnalysisType],
			[SentimentId],
			[AppId],
			[Score],
			[CreatedDate],
			[CreatedByUserId],
			[LastModifiedDate],
			[LastModifiedByUserId],
			[TimeStamp],
			[EndDate]

			)
		VALUES (
			@VCC,
			@InteractionId,
			@InteractionSection,
			@InteractionPart,
			@InteractionType,
			@InteractionInterval,
			@AnalysisType,
			@SentimentId,
			@AppId,
			@Score,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE(),
			@LastModifiedByUserId,
			GETUTCDATE(),
			@EndDate
		)
	END
	
	

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Altering Procedure [dbo].[SaveProcess]...';


GO

ALTER PROCEDURE [dbo].[SaveProcess] (
	@VCC Varchar(50) = NULL,
	@Name Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@ClientId Varchar(50) = NULL,
	@Type VARCHAR(50),
	@Status Varchar(50) = NULL,
	@StartDate Datetime = NULL,
	@EndDate Datetime = NULL,
	@MinDurationTime Numeric(18, 2) = NULL,
	@MaxDurationTime Numeric(18, 2) = NULL,
	@Language VARCHAR(25) = NULL,
	@DictionaryId VARCHAR(50) = NULL,
	@Environment Varchar(50) = NULL,
	@QueryId Varchar(50) = NULL,
	@QueryDataId Varchar(50) = NULL,
	@QueryDataIdDate Datetime = NULL,
	@BatchScheduleId VARCHAR(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@Retranscription BIT = 0,
	@Diarization BIT = 0,
	@ChannelChange BIT = 0
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Process]
	SET [Description] = @Description,
		[ClientId] = @ClientId,
		[Status] = @Status,
		[Type] = @Type,
		[StartDate] = @StartDate,
		[EndDate] = @EndDate,
		[MinDurationTime] = @MinDurationTime,
		[MaxDurationTime] = @MaxDurationTime,
		[Language] = @Language,
		[DictionaryId] = @DictionaryId,
		[Environment] = @Environment,
		[QueryId] = @QueryId,
		[QueryDataId] = @QueryDataId,
		[QueryDataIdDate] = @QueryDataIdDate,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
		
	WHERE [VCC] = @VCC
    AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Process] (
			[VCC], [Name], [Description],
			[ClientId], [Status], [Type], [StartDate],
			[EndDate], [MinDurationTime], [MaxDurationTime], 
			[Language], [DictionaryId], [Environment], 
			[QueryId], [QueryDataId], [QueryDataIdDate],
			[BatchScheduleId], 
			[CreatedDate], [CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp], [Retranscription], [Diarization], [ChannelChange]
			)
		VALUES (
			@VCC, @Name, @Description,
			@ClientId, @Status, @Type, @StartDate,
			@EndDate, @MinDurationTime, @MaxDurationTime, 
			@Language, @DictionaryId, @Environment, 
			@QueryId, @QueryDataId, @QueryDataIdDate, 
			@BatchScheduleId,
			@CreatedDate, @CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE(), @Retranscription, @Diarization, @ChannelChange
		)
	END
	--En caso de retranscripcion regresar todos los audios a su estado inicial 
	IF @Retranscription = 1
	BEGIN
	  UPDATE A
	  SET A.[IsCancel] = 1,
	  A.[IsTranscribed] = null,
	  A.[init] = null,
	  A.[IsDiariced] = null,
	  A.[ChannelsChanged] = null
	  FROM Audio A inner join ProcessAudio PA on A.id = PA.AudioId
	  WHERE 
	  PA.[VCC] = @VCC AND
	  PA.[ProcessId] = @Name 


	  UPDATE ASY
	  SET ASY.[IsCancel] = 1,
	  ASY.[IsTranscribed] = null
	  
	  FROM AsyncInteraction ASY inner join ProcessAsyncInteraction PAS on ASY.id = PAS.InteractionId
	  WHERE 
	  PAS.[VCC] =  @VCC AND
	  PAS.[ProcessId] = @Name
	
	  
	  
	END

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Refreshing Procedure [dbo].[GetAudiosTranscriptions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosTranscriptions]';


GO
PRINT N'Refreshing Procedure [dbo].[GetEvaluations]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluations]';


GO
PRINT N'Update complete.';


GO
